.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include res_enum.inc


res_type MACRO reg
		cmp edi, 0
		jg @BB
		.if reg == RT_ACCELERATOR
			invoke szCopy, CADD("ACCELERATOR"), ADDR buf
		.elseif reg == RT_ANICURSOR
			invoke szCopy, CADD("ANICURSOR"), ADDR buf
		.elseif reg == RT_ANIICON
			invoke szCopy, CADD("ANIICON"), ADDR buf
		.elseif reg == RT_BITMAP
			invoke szCopy, CADD("BITMAP"), ADDR buf
		.elseif reg == RT_CURSOR
			invoke szCopy, CADD("CURSOR"), ADDR buf
		.elseif reg == RT_DIALOG
			invoke szCopy, CADD("DIALOG"), ADDR buf
		.elseif reg == RT_DLGINCLUDE
			invoke szCopy, CADD("DLGINCLUDE"), ADDR buf
		.elseif reg == RT_FONT
			invoke szCopy, CADD("FONT"), ADDR buf
		.elseif reg == RT_FONTDIR
			invoke szCopy, CADD("FONTDIR"), ADDR buf
		.elseif reg == RT_GROUP_CURSOR
			invoke szCopy, CADD("GROUP_CURSOR"), ADDR buf
		.elseif reg == RT_GROUP_ICON
			invoke szCopy, CADD("GROUP_ICON"), ADDR buf
		.elseif reg == RT_HTML
			invoke szCopy, CADD("HTML"), ADDR buf
		.elseif reg == RT_ICON
			invoke szCopy, CADD("ICON"), ADDR buf			
		.elseif reg == RT_MANIFEST
			invoke szCopy, CADD("MANIFEST"), ADDR buf
		.elseif reg == RT_MENU
			invoke szCopy, CADD("MENU"), ADDR buf
		.elseif reg == 11;MESSAGETABLE
			invoke szCopy, CADD("MESSAGETABLE"), ADDR buf
		.elseif reg == RT_PLUGPLAY
			invoke szCopy, CADD("PLUGPLAY"), ADDR buf
		.elseif reg == RT_RCDATA
			invoke szCopy, CADD("RCDATA"), ADDR buf
		.elseif reg == RT_STRING
			invoke szCopy, CADD("STRING"), ADDR buf
		.elseif reg == RT_VERSION
			invoke szCopy, CADD("VERSION"), ADDR buf
		.elseif reg == RT_VXD
			invoke szCopy, CADD("VXD"), ADDR buf
		.else
		@BB:
			test   reg, 80000000h
			jz     @CC
			xor    reg, 80000000h
			add    reg, ebx
			push   ecx
			push   edi
			push   esi
			xor    ecx, ecx
			mov    cx, word ptr [reg]
			add reg, 2
			lea edi, buf
		@CCX:	
			mov al, byte ptr [reg]	
			mov byte ptr [edi], al 
			add reg, 2
			inc edi
			dec ecx
			cmp ecx, 0
			jnz @CCX
			mov byte ptr [edi], 0
			pop    esi
			pop    edi
			pop    ecx
			jmp    @DD
		@CC:	
			invoke dwtoa, reg, ADDR buf
		@DD:
		.endif
ENDM

.data
	tree  dd 0
	fname dd 0
	tree_list dd 0
.code

start:

	invoke GetModuleHandle,NULL
	mov	   hInstance,eax

    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL tree_bmp:DWORD
	
	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		invoke GetDlgItem, hWin, 1001
		mov    tree, eax
		
		mov    tree_list, FUNC(ImageList_Create, 16, 16, ILC_COLOR24, 6, 12)
		mov    tree_bmp,  FUNC(LoadBitmap, hInstance, 20000)
		invoke ImageList_Add, tree_list, tree_bmp, 0
		invoke SendMessage, tree, TVM_SETIMAGELIST, TVSIL_NORMAL, tree_list
		invoke DeleteObject, tree_bmp

	.elseif eax==WM_COMMAND
		mov eax,wParam
		.if eax==1002
			mov fname, FUNC(OpenFileDialog, hWin, hInstance, CADD("Choose file"), CTXT("Executive files",0,"*.exe;*.dll",0))
			.if byte ptr [eax] != 0
				invoke LoadRes, fname
			.endif
		.endif
	.elseif eax==WM_CLOSE
		invoke ImageList_Destroy, tree_list
		invoke EndDialog,hWin,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

LoadRes proc f_name:DWORD
	LOCAL tvin    :TV_INSERTSTRUCT
	LOCAL hMapping:DWORD
	LOCAL pMapping:DWORD
	LOCAL file:DWORD
	LOCAL buf[64]:DWORD
	
	invoke SendMessage, tree, TVM_DELETEITEM, 0, 0
	mov    tvin.hInsertAfter,    TVI_LAST
	mov    tvin.hParent,         0
	mov    tvin.item.imask,      TVIF_TEXT+TVIF_PARAM+TVIF_IMAGE+TVIF_SELECTEDIMAGE
	mov    tvin.item.lParam,     0
	mov    tvin.item.cchTextMax, 64

	;---------------------------------------------------------------------------------------------
	mov    file, fopen(f_name)
	invoke CreateFileMapping, file, NULL, PAGE_READONLY, 0, 0, 0
	.if eax!=NULL
		mov hMapping, eax
		invoke MapViewOfFile, hMapping, FILE_MAP_READ, 0, 0, 0
		.if eax!=NULL
			mov    pMapping, eax
			;-----------------------
			mov    edi, eax
			mov    ebx, (IMAGE_DOS_HEADER ptr [eax]).e_lfanew
			add    ebx, edi ; RVA + start_addr
			xor    ecx, ecx
			mov    cx, (IMAGE_NT_HEADERS ptr [ebx]).FileHeader.NumberOfSections
			add    ebx, sizeof IMAGE_NT_HEADERS 
			.while ecx > 0
				.if dword ptr (IMAGE_SECTION_HEADER ptr [ebx]+1).Name1 == 'crsr'
					.break	 		
				.endif
				dec ecx
				add ebx, sizeof IMAGE_SECTION_HEADER
			.endw
			mov    esi, (IMAGE_SECTION_HEADER ptr [ebx]).PointerToRawData				
			add    esi, edi
			mov    ebx, esi       ; we'll add offest to -=ROOT=- (this is root)
			mov    edi, -1         ; reg for image list
			;TYPE->NAME/ID->LANGUAGE ENUM oO|begin|Oo
			push   13  ; KAPUT
			push   0   ; root-child
			push   esi ; root address
	@A1:		
			pop    esi ; retrieve directory address
			cmp    esi, 13 ; IS IT KAPUT ?
			jz     @A3
			pop    tvin.hParent ; retrieve child
			xor    ecx, ecx
			mov    cx, (ResDir ptr [esi]).NumberOfNamedEntries
			add    cx, (ResDir ptr [esi]).NumberOfIdEntries ; number of entries in directory
			add    esi, sizeof ResDir
			;------------------------------------------
			inc    edi
	@@:		
			cmp    ecx, 0
			jz     @A1            ; go or not to go to new directory
			;-------ooooooooooooooooooooooooooooooooooooooooooooooooooO
			push   ecx
			mov    edx, (ResDirEntry ptr [esi]).NameRVA
	@B1:
			res_type edx		
			lea    edx, buf
	@B2:		
			mov    tvin.item.pszText, edx
			;---------------
			mov    edx, (ResDirEntry ptr [esi]).DataEntry
			test   edx, 80000000h ; is hi-bit set ?
			jz     @B3
			cmp    edi, 2
			jnz    @B3
			dec    edi
	@B3:
			mov    eax, edi
			shl    eax, 1
			mov    tvin.item.iImage, eax ; 0 2 4
			inc    eax
			mov    tvin.item.iSelectedImage, eax ; 1 3 5
			invoke SendMessage, tree, TVM_INSERTITEM, 0, ADDR tvin
			pop    ecx
			;-------ooooooooooooooooooooooooooooooooooooooooooooooooooO
			mov    edx, (ResDirEntry ptr [esi]).DataEntry
			add    esi, sizeof ResDirEntry
			dec    ecx
			test   edx, 80000000h ; is hi-bit set ?
			jnz    @A2
			cmp    ecx, 0
			jnz    @B
			dec    edi
			jmp    @B  ; after each languageID
	@A2:
			xor    edx, 80000000h ; clear hi-bit
			add    edx, ebx       ; offset + root
			push   eax            ; save address for future visits
			push   edx            ; if it's directory, save as parent
			jmp    @B
	@A3:		
			;TYPE->NAME/ID->LANGUAGE ENUM oO|end|Oo
		.endif
		invoke UnmapViewOfFile, pMapping
	.endif
	invoke CloseHandle, hMapping
	fclose(file)
	;---------------------------------------------------------------------------------------------
	ret

LoadRes endp

end start
